
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

// *****************************************************************************
// Archivo: ControlDeAsistencia.cpp
// Descripcin: Clase ControlDeAsistencia (cdigo)
// Autor: Ezequiel Gastn Miravalles
// ltima modificacin: 28/07/2009
// Website: http://www.neoegm.com/
// *****************************************************************************

#include "ControlDeAsistencia.h"

ControlDeAsistencia::ControlDeAsistencia()
{
	Persona pAdmin;

	pAdmin.DNI(-1234);
	pAdmin.NombreCompleto("Administrador");
	pAdmin.Password("prueba");
	pAdmin.Admin(true);
	
	m_lPersonas.Agregar(pAdmin);
}

Persona* ControlDeAsistencia::PersonaPorDNI(long nDNI)
{
	for (int i = 0; i < m_lPersonas.Cantidad(); i++)
	{
		Persona& rpPersona = m_lPersonas[i];

		if (rpPersona.DNI() == nDNI)
			return &rpPersona;
	}

	return NULL;
}
