
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

// *****************************************************************************
// Archivo: Hora.h
// Descripcin: Clase Hora (header)
// Autor: Ezequiel Gastn Miravalles
// ltima modificacin: 28/07/2009
// Website: http://www.neoegm.com/
// *****************************************************************************

#pragma once

#include <ctime>
#include <iostream>

class Hora
{
	time_t m_tHora;

public:
	Hora() { m_tHora = 0; }

	void CargarHoraActual() { time(&m_tHora); }

	int Horas() { return GetTM()->tm_hour; }
	int Minutos() { return GetTM()->tm_min; }
	int Segundos() { return GetTM()->tm_sec; }

	int Dia() { return GetTM()->tm_mday; }
	int Mes() { return GetTM()->tm_mon + 1; }
	int Ano() { return GetTM()->tm_year + 1900; }

	int DiaSemana() { return GetTM()->tm_wday; }	//Desde el Domingo
	int DiaAno() { return GetTM()->tm_yday; }		//0 - 365

protected:
	tm * GetTM() { return localtime(&m_tHora); }
		//struct tm {
		//	int tm_sec;     /* seconds after the minute - [0,59] */
		//	int tm_min;     /* minutes after the hour - [0,59] */
		//	int tm_hour;    /* hours since midnight - [0,23] */
		//	int tm_mday;    /* day of the month - [1,31] */
		//	int tm_mon;     /* months since January - [0,11] */
		//	int tm_year;    /* years since 1900 */
		//	int tm_wday;    /* days since Sunday - [0,6] */
		//	int tm_yday;    /* days since January 1 - [0,365] */
		//	int tm_isdst;   /* daylight savings time flag */
		//};
};

std::ostream& operator<<(std::ostream& oStream, Hora hHora);
