
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

//---------------------------------------------------------------------------
//
// Name:        wxAltaUsuarioDlg.h
// Author:      NeoEGM
// Created:     29/06/2009 8:27:24 PM
// Description: wxAltaUsuarioDlg class declaration
//
//---------------------------------------------------------------------------

#ifndef __WXALTAUSUARIODLG_h__
#define __WXALTAUSUARIODLG_h__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/button.h>
#include <wx/checkbox.h>
#include <wx/textctrl.h>
#include <wx/stattext.h>
#include <wx/sizer.h>
////Header Include End

#include "Persona.h"

////Dialog Style Start
#undef wxAltaUsuarioDlg_STYLE
#define wxAltaUsuarioDlg_STYLE wxCAPTION | wxRESIZE_BORDER | wxSTAY_ON_TOP | wxCLOSE_BOX
////Dialog Style End

class wxAltaUsuarioDlg : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		wxAltaUsuarioDlg(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("Alta de usuario"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxAltaUsuarioDlg_STYLE);
		virtual ~wxAltaUsuarioDlg();
		void WxCancelarClick(wxCommandEvent& event);
		void WxAceptarClick(wxCommandEvent& event);
		
		Persona m_pPersona;
	
	private:
		//Do not add custom control declarations between 
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxStaticText *WxStaticText3;
		wxButton *WxCancelar;
		wxButton *WxAceptar;
		wxBoxSizer *WxBoxSizer7;
		wxCheckBox *WxAdmin;
		wxBoxSizer *WxBoxSizer6;
		wxTextCtrl *WxPassword;
		wxStaticText *WxStaticText5;
		wxBoxSizer *WxBoxSizer5;
		wxTextCtrl *WxNombre;
		wxStaticText *WxStaticText4;
		wxBoxSizer *WxBoxSizer4;
		wxTextCtrl *WxDNI;
		wxStaticText *WxStaticText1;
		wxBoxSizer *WxBoxSizer3;
		wxStaticText *WxStaticText2;
		wxBoxSizer *WxBoxSizer2;
		wxBoxSizer *WxBoxSizer1;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_WXSTATICTEXT3 = 1013,
			ID_WXCANCELAR = 1025,
			ID_WXACEPTAR = 1024,
			ID_WXADMIN = 1029,
			ID_WXEDIT1 = 1016,
			ID_WXDNI = 1016,
			ID_WXSTATICTEXT1 = 1015,
			ID_WXSTATICTEXT2 = 1012,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
	
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
};

#endif
