
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

//---------------------------------------------------------------------------
//
// Name:        wxAsistenciaDlg.cpp
// Author:      NeoEGM
// Created:     29/06/2009 11:39:25 PM
// Description: wxAsistenciaDlg class implementation
//
//---------------------------------------------------------------------------

#include "wxAsistenciaDlg.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// wxAsistenciaDlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(wxAsistenciaDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(wxAsistenciaDlg::OnClose)
	EVT_INIT_DIALOG(wxAsistenciaDlg::wxAsistenciaDlgInitDialog)
	EVT_BUTTON(ID_WXCANCELAR,wxAsistenciaDlg::WxCancelarClick)
	EVT_BUTTON(ID_WXACEPTAR,wxAsistenciaDlg::WxAceptarClick)
	EVT_TEXT_ENTER(ID_WXMEMO1,wxAsistenciaDlg::WxAceptarClick)
END_EVENT_TABLE()
////Event Table End

wxAsistenciaDlg::wxAsistenciaDlg(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

wxAsistenciaDlg::~wxAsistenciaDlg()
{
} 

void wxAsistenciaDlg::CreateGUIControls()
{
	Hora hHora;
	hHora.CargarHoraActual();

	m_aAsistencia.HoraEvento(hHora);
	
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxBoxSizer1 = new wxBoxSizer(wxVERTICAL);
	this->SetSizer(WxBoxSizer1);
	this->SetAutoLayout(true);

	WxBoxSizer2 = new wxBoxSizer(wxVERTICAL);
	WxBoxSizer1->Add(WxBoxSizer2, 1, wxALIGN_CENTER | wxALL, 5);

	WxStaticText4 = new wxStaticText(this, ID_WXSTATICTEXT4, wxT("         "), wxPoint(210,5), wxDefaultSize, 0, wxT("WxStaticText4"));
	WxStaticText4->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxStaticText4,1,wxALIGN_CENTER | wxALL,5);

	WxUsername = new wxStaticText(this, ID_WXUSERNAME, wxT("Usuario: \"XXXXXX\""), wxPoint(133,67), wxDefaultSize, 0, wxT("WxUsername"));
	WxUsername->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxUsername,0,wxALIGN_CENTER | wxALL,20);

	WxBoxSizer3 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer2->Add(WxBoxSizer3, 0, wxALIGN_LEFT | wxALL, 0);

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("Tipo"), wxPoint(5,7), wxSize(150, 37), wxST_NO_AUTORESIZE, wxT("WxStaticText1"));
	WxStaticText1->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer3->Add(WxStaticText1,0,wxALIGN_CENTER | wxALL,5);

	wxArrayString arrayStringFor_WxChoice1;
	arrayStringFor_WxChoice1.Add(wxT("Ingreso"));
	arrayStringFor_WxChoice1.Add(wxT("Salida"));
	arrayStringFor_WxChoice1.Add(wxT("Salida a almorzar"));
	arrayStringFor_WxChoice1.Add(wxT("Vuelta de almorzar"));
	WxChoice1 = new wxChoice(this, ID_WXCHOICE1, wxPoint(165,5), wxSize(246,41), arrayStringFor_WxChoice1, 0, wxDefaultValidator, wxT("WxChoice1"));
	WxChoice1->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxChoice1->SetSelection(0);
	WxBoxSizer3->Add(WxChoice1,0,wxALIGN_CENTER | wxALL,5);

	WxBoxSizer4 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer2->Add(WxBoxSizer4, 0, wxALIGN_CENTER | wxALL, 0);

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT("Justificacin"), wxPoint(5,53), wxSize(150, 37), wxST_NO_AUTORESIZE, wxT("WxStaticText2"));
	WxStaticText2->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer4->Add(WxStaticText2,0,wxALIGN_LEFT | wxALIGN_TOP | wxEXPAND | wxALL,5);

	WxMemo1 = new wxTextCtrl(this, ID_WXMEMO1, wxT(""), wxPoint(165,5), wxSize(326,133), wxTE_CHARWRAP | wxTE_LINEWRAP | wxTE_MULTILINE, wxDefaultValidator, wxT("WxMemo1"));
	WxMemo1->SetMaxLength(0);
	WxMemo1->SetFocus();
	WxMemo1->SetInsertionPointEnd();
	WxMemo1->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer4->Add(WxMemo1,0,wxALIGN_CENTER | wxALL,5);

	WxBoxSizer5 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer2->Add(WxBoxSizer5, 0, wxALIGN_CENTER | wxTOP, 30);

	WxAceptar = new wxButton(this, ID_WXACEPTAR, wxT("Aceptar"), wxPoint(5,5), wxSize(118,73), 0, wxDefaultValidator, wxT("WxAceptar"));
	WxAceptar->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer5->Add(WxAceptar,0,wxALIGN_CENTER | wxALL,5);

	WxCancelar = new wxButton(this, ID_WXCANCELAR, wxT("Cancelar"), wxPoint(133,5), wxSize(118,73), 0, wxDefaultValidator, wxT("WxCancelar"));
	WxCancelar->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer5->Add(WxCancelar,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText3 = new wxStaticText(this, ID_WXSTATICTEXT3, wxT("         "), wxPoint(210,436), wxDefaultSize, 0, wxT("WxStaticText3"));
	WxStaticText3->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxStaticText3,1,wxALIGN_CENTER | wxALL,5);

	SetTitle(wxT("Asistencia"));
	SetIcon(wxNullIcon);
	
	GetSizer()->Layout();
	GetSizer()->Fit(this);
	GetSizer()->SetSizeHints(this);
	Center();
	
	////GUI Items Creation End
	
	WxAceptar->SetDefault();
	
	Maximize();
}

void wxAsistenciaDlg::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}

/*
 * WxCancelarClick
 */
void wxAsistenciaDlg::WxCancelarClick(wxCommandEvent& event)
{
	EndModal(wxCANCEL);
}

/*
 * WxAceptarClick
 */
void wxAsistenciaDlg::WxAceptarClick(wxCommandEvent& event)
{
	m_aAsistencia.Tipo(WxChoice1->GetSelection()+1);
	m_aAsistencia.Justificacion(WxMemo1->GetValue().c_str());
	
	EndModal(wxOK);
}

/*
 * wxAsistenciaDlgInitDialog
 */
void wxAsistenciaDlg::wxAsistenciaDlgInitDialog(wxInitDialogEvent& event)
{
	WxChoice1->SetFocus();
}
