
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

//---------------------------------------------------------------------------
//
// Name:        wxAsistenciaDlg.h
// Author:      NeoEGM
// Created:     29/06/2009 11:39:25 PM
// Description: wxAsistenciaDlg class declaration
//
//---------------------------------------------------------------------------

#ifndef __WXASISTENCIADLG_h__
#define __WXASISTENCIADLG_h__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/button.h>
#include <wx/textctrl.h>
#include <wx/choice.h>
#include <wx/stattext.h>
#include <wx/sizer.h>
////Header Include End

#include "Asistencia.h"

////Dialog Style Start
#undef wxAsistenciaDlg_STYLE
#define wxAsistenciaDlg_STYLE wxCAPTION | wxSTAY_ON_TOP | wxCLOSE_BOX
////Dialog Style End

class wxAsistenciaDlg : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		wxAsistenciaDlg(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("Asistencia"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxAsistenciaDlg_STYLE);
		virtual ~wxAsistenciaDlg();
		
		void SetUsername(wxString sString) { WxUsername->SetLabel("Usuario: \"" + sString + "\""); }
		
		Asistencia m_aAsistencia;
		void WxCancelarClick(wxCommandEvent& event);
		void WxAceptarClick(wxCommandEvent& event);
		void wxAsistenciaDlgInitDialog(wxInitDialogEvent& event);
	
	private:
		//Do not add custom control declarations between 
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxStaticText *WxStaticText3;
		wxButton *WxCancelar;
		wxButton *WxAceptar;
		wxBoxSizer *WxBoxSizer5;
		wxTextCtrl *WxMemo1;
		wxStaticText *WxStaticText2;
		wxBoxSizer *WxBoxSizer4;
		wxChoice *WxChoice1;
		wxStaticText *WxStaticText1;
		wxBoxSizer *WxBoxSizer3;
		wxStaticText *WxUsername;
		wxStaticText *WxStaticText4;
		wxBoxSizer *WxBoxSizer2;
		wxBoxSizer *WxBoxSizer1;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_WXSTATICTEXT3 = 1016,
			ID_WXCANCELAR = 1015,
			ID_WXACEPTAR = 1014,
			ID_WXMEMO1 = 1011,
			ID_WXSTATICTEXT2 = 1010,
			ID_WXCHOICE1 = 1008,
			ID_WXSTATICTEXT1 = 1004,
			ID_WXUSERNAME = 1018,
			ID_WXSTATICTEXT4 = 1017,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
	
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
};

#endif
