
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

//---------------------------------------------------------------------------
//
// Name:        wxControlAsistenciaDlg.cpp
// Author:      NeoEGM
// Created:     23/06/2009 8:11:25 PM
// Description: wxControlAsistenciaDlg class implementation
//
//---------------------------------------------------------------------------

#include "wxControlAsistenciaDlg.h"
#include "wxAdministracionDlg.h"
#include "wxAsistenciaDlg.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// wxControlAsistenciaDlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(wxControlAsistenciaDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(wxControlAsistenciaDlg::OnClose)
	EVT_BUTTON(ID_WXBUTTON1,wxControlAsistenciaDlg::WxButton1Click)
END_EVENT_TABLE()
////Event Table End

wxControlAsistenciaDlg::wxControlAsistenciaDlg(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

wxControlAsistenciaDlg::~wxControlAsistenciaDlg()
{
} 

void wxControlAsistenciaDlg::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxBoxSizer1 = new wxBoxSizer(wxVERTICAL);
	this->SetSizer(WxBoxSizer1);
	this->SetAutoLayout(true);

	WxBoxSizer5 = new wxBoxSizer(wxVERTICAL);
	WxBoxSizer1->Add(WxBoxSizer5, 1, wxALIGN_CENTER | wxALL, 5);

	WxStaticText4 = new wxStaticText(this, ID_WXSTATICTEXT4, wxT("    "), wxPoint(157,5), wxDefaultSize, 0, wxT("WxStaticText4"));
	WxStaticText4->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer5->Add(WxStaticText4,1,wxALIGN_CENTER | wxALL,5);

	WxBoxSizer2 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer5->Add(WxBoxSizer2, 0, wxALIGN_LEFT | wxALL, 0);

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("DNI"), wxPoint(5,8), wxSize(139, 27), wxST_NO_AUTORESIZE, wxT("WxStaticText1"));
	WxStaticText1->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxStaticText1,0,wxALIGN_LEFT | wxALL,5);

	WxDNI = new wxTextCtrl(this, ID_WXDNI, wxT(""), wxPoint(154,29), wxSize(191,34), 0, wxDefaultValidator, wxT("WxDNI"));
	WxDNI->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxDNI,0,wxALIGN_RIGHT | wxALIGN_CENTER | wxALL,5);

	WxBoxSizer3 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer5->Add(WxBoxSizer3, 0, wxALIGN_LEFT | wxALL, 0);

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT("Contrasea"), wxPoint(5,8), wxSize(139, 27), wxST_NO_AUTORESIZE, wxT("WxStaticText2"));
	WxStaticText2->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer3->Add(WxStaticText2,0,wxALIGN_CENTER | wxALL,5);

	WxPass = new wxTextCtrl(this, ID_WXPASS, wxT(""), wxPoint(154,5), wxSize(191,34), wxTE_PASSWORD, wxDefaultValidator, wxT("WxPass"));
	WxPass->SetBackgroundColour(wxColour(245,237,175));
	WxPass->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer3->Add(WxPass,0,wxALIGN_CENTER | wxALL,5);

	WxButton1 = new wxButton(this, ID_WXBUTTON1, wxT("Ingresar"), wxPoint(114,140), wxSize(121,44), 0, wxDefaultValidator, wxT("WxButton1"));
	WxButton1->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer5->Add(WxButton1,0,wxALIGN_RIGHT | wxALL,5);

	WxStaticText3 = new wxStaticText(this, ID_WXSTATICTEXT3, wxT("    "), wxPoint(157,194), wxDefaultSize, 0, wxT("WxStaticText3"));
	WxStaticText3->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer5->Add(WxStaticText3,1,wxALIGN_CENTER | wxALL,5);

	SetTitle(wxT("Control de Asistencia de Personal"));
	SetIcon(wxNullIcon);
	
	GetSizer()->Layout();
	GetSizer()->Fit(this);
	GetSizer()->SetSizeHints(this);
	Center();
	
	////GUI Items Creation End
	
	WxButton1->SetDefault();
	
	Maximize();
}

void wxControlAsistenciaDlg::OnClose(wxCloseEvent& /*event*/)
{
	//Destroy();
}

/*
 * WxButton1Click
 */
void wxControlAsistenciaDlg::WxButton1Click(wxCommandEvent& event)
{
	long nDNI;
	WxDNI->GetValue().ToLong(&nDNI);
	
	Persona *pPersona = m_ctMain.PersonaPorDNI(nDNI);

	if (!pPersona)
		wxMessageBox("DNI desconocido", wxMessageBoxCaptionStr, wxOK | wxCENTRE | wxICON_EXCLAMATION);
	else
	{
		if (pPersona->CompararPassword(WxPass->GetValue().c_str()))
		{
			//wxMessageBox("Usuario \"" + pPersona->NombreCompleto() + "\" reconocido.");

			if (pPersona->Admin())
			{
				//wxMessageBox("Ingresando a la interfase de administracin...");
				
				wxAdministracionDlg dlgAdmin(this);
				dlgAdmin.SetControlAsistencia(&m_ctMain);
				dlgAdmin.SetUsername((const char*)pPersona->NombreCompleto());

				if (dlgAdmin.ShowModal() == wxOK)
					Destroy();	//Quit application
			}
			else
			{
				wxAsistenciaDlg dlgAsistencia(this);
				dlgAsistencia.SetUsername((const char*)pPersona->NombreCompleto());
				
				if (dlgAsistencia.ShowModal() == wxOK)
				{
					pPersona->AgregarEvento(dlgAsistencia.m_aAsistencia);
				}
			}
		}
		else
		{
			wxMessageBox("Contrasea incorrecta", wxMessageBoxCaptionStr, wxOK | wxCENTRE | wxICON_EXCLAMATION);
			//Pause();
		}
	}
	
	WxDNI->SetValue("");
	WxPass->SetValue("");

	WxDNI->SetFocus();
}
