
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

//---------------------------------------------------------------------------
//
// Name:        wxListaUsuariosDlg.cpp
// Author:      NeoEGM
// Created:     30/06/2009 1:32:45 AM
// Description: wxListaUsuariosDlg class implementation
//
//---------------------------------------------------------------------------

#include "wxListaUsuariosDlg.h"

#include <sstream>
using std::stringstream;

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// wxListaUsuariosDlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(wxListaUsuariosDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(wxListaUsuariosDlg::OnClose)
	EVT_INIT_DIALOG(wxListaUsuariosDlg::wxListaUsuariosDlgInitDialog)
	EVT_BUTTON(ID_WXBUTTON1,wxListaUsuariosDlg::WxButton1Click)
	
	EVT_LIST_ITEM_SELECTED(ID_WXLISTCTRL1,wxListaUsuariosDlg::WxListCtrl1Selected)
	EVT_LIST_ITEM_DESELECTED(ID_WXLISTCTRL1,wxListaUsuariosDlg::WxListCtrl1Deselected)
END_EVENT_TABLE()
////Event Table End

wxListaUsuariosDlg::wxListaUsuariosDlg(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	m_pctMain = NULL;
	CreateGUIControls();
}

wxListaUsuariosDlg::~wxListaUsuariosDlg()
{
} 

void wxListaUsuariosDlg::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxBoxSizer1 = new wxBoxSizer(wxVERTICAL);
	this->SetSizer(WxBoxSizer1);
	this->SetAutoLayout(true);

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("Usuarios"), wxPoint(77,5), wxDefaultSize, 0, wxT("WxStaticText1"));
	WxStaticText1->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer1->Add(WxStaticText1,0,wxALIGN_LEFT | wxALL,5);

	WxListCtrl1 = new wxListCtrl(this, ID_WXLISTCTRL1, wxPoint(5,52), wxSize(250,150), wxLC_REPORT);
	WxListCtrl1->SetFont(wxFont(16, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer1->Add(WxListCtrl1,1,wxALIGN_LEFT | wxALIGN_CENTER | wxEXPAND | wxALL,5);

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT("Asistencias"), wxPoint(64,212), wxDefaultSize, 0, wxT("WxStaticText2"));
	WxStaticText2->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer1->Add(WxStaticText2,0,wxALIGN_LEFT | wxALL,5);

	WxListCtrl2 = new wxListCtrl(this, ID_WXLISTCTRL2, wxPoint(5,259), wxSize(250,150), wxLC_REPORT | wxLC_SINGLE_SEL);
	WxListCtrl2->SetFont(wxFont(16, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer1->Add(WxListCtrl2,1,wxALIGN_LEFT | wxEXPAND | wxALL,5);

	WxButton1 = new wxButton(this, ID_WXBUTTON1, wxT("Cerrar"), wxPoint(68,444), wxSize(123,49), 0, wxDefaultValidator, wxT("WxButton1"));
	WxButton1->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer1->Add(WxButton1,0,wxALIGN_CENTER | wxALL,30);

	SetTitle(wxT("Lista de usuarios"));
	SetIcon(wxNullIcon);
	
	GetSizer()->Layout();
	GetSizer()->Fit(this);
	GetSizer()->SetSizeHints(this);
	Center();
	
	////GUI Items Creation End
	
	Maximize();
}

void wxListaUsuariosDlg::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}

void wxListaUsuariosDlg::CargarUsuarios()
{
	WxListCtrl1->DeleteAllItems();
	
	long nItem;
	
	for (int i = 0; i < m_pctMain->CantidadDePersonas(); i++)
	{
		Persona *pPersona = m_pctMain->PersonaItem(i);

		if (pPersona)	//Por las dudas
		{
			nItem = WxListCtrl1->InsertItem(i, wxString::Format("%ld", pPersona->DNI()));
			WxListCtrl1->SetItem(nItem, 1, (const char*)pPersona->NombreCompleto());
			WxListCtrl1->SetItem(nItem, 2, (const char*)pPersona->Password());
			WxListCtrl1->SetItem(nItem, 3, pPersona->Admin()?"S":"");
			WxListCtrl1->SetItem(nItem, 4, wxString::Format("%d", pPersona->CantidadEventos()));
			WxListCtrl1->SetItemData(nItem, i);
		}
	}
}

/*
 * WxButton1Click
 */
void wxListaUsuariosDlg::WxButton1Click(wxCommandEvent& event)
{
	Destroy();
}

void wxListaUsuariosDlg::RefrescarListaAsistencia(int nPersonaItem)
{
	WxListCtrl2->DeleteAllItems();
	
	if (nPersonaItem != -1)
	{
		long nPersona = WxListCtrl1->GetItemData(nPersonaItem);
		
		Persona *pPersona = m_pctMain->PersonaItem(nPersona);
		
		if (pPersona)
		{
			long nItem;

			for (int i = 0; i < pPersona->ListaAsistencia().Cantidad(); i++)
			{
				Asistencia *paAsistencia = pPersona->ListaAsistencia().Elem(i);
				
				stringstream sStr;
				sStr << paAsistencia->HoraEvento();
				
				if (paAsistencia)
				{
					nItem = WxListCtrl2->InsertItem(i, sStr.str().c_str());
					WxListCtrl2->SetItem(nItem, 1, paAsistencia->TipoTexto());
					WxListCtrl2->SetItem(nItem, 2, (const char*)paAsistencia->Justificacion());
					WxListCtrl2->SetItemData(nItem, i);
				}
			}
			
			ResizeColumns(WxListCtrl2);
		}
	}
}

void wxListaUsuariosDlg::ResizeColumns(wxListCtrl* pListCtrl)
{
	for (int i = 0; i < pListCtrl->GetColumnCount(); i++)
		pListCtrl->SetColumnWidth( i, wxLIST_AUTOSIZE_USEHEADER );
}

/*
 * wxListaUsuariosDlgInitDialog
 */
void wxListaUsuariosDlg::wxListaUsuariosDlgInitDialog(wxInitDialogEvent& event)
{
	WxListCtrl1->InsertColumn(0, "DNI");
	WxListCtrl1->InsertColumn(1, "Nombre completo");
	WxListCtrl1->InsertColumn(2, "Password");
	WxListCtrl1->InsertColumn(3, "Administrador");
	WxListCtrl1->InsertColumn(4, "Cantidad de eventos");
	
	WxListCtrl2->InsertColumn(0, "Hora");
	WxListCtrl2->InsertColumn(1, "Tipo");
	WxListCtrl2->InsertColumn(2, "Justificacin");
	
	CargarUsuarios();
	
	ResizeColumns(WxListCtrl1);
	ResizeColumns(WxListCtrl2);
}

/*
 * WxListCtrl1Selected
 */
void wxListaUsuariosDlg::WxListCtrl1Selected(wxListEvent& event)
{
	//wxMessageBox(wxString::Format("Selected %ld", event.GetItem().GetId()));
	
	RefrescarListaAsistencia(event.GetItem().GetId());
}

/*
 * WxListCtrl1Deselected
 */
void wxListaUsuariosDlg::WxListCtrl1Deselected(wxListEvent& event)
{
	//wxMessageBox("Selected -1");
	
	RefrescarListaAsistencia(-1);
}
